package pro.litvinovg.libreoffice;

import static pro.litvinovg.libreoffice.metadata.Document.METADATA_EXTENSION;

import com.sun.star.beans.UnknownPropertyException;
import com.sun.star.beans.XPropertySet;
import com.sun.star.container.NoSuchElementException;
import com.sun.star.lang.WrappedTargetException;
import com.sun.star.text.XText;
import com.sun.star.text.XTextContent;
import com.sun.star.text.XTextField;
import com.sun.star.text.XTextRange;
import com.sun.star.uno.UnoRuntime;

public class MetadataCleaner extends DocumentParserImpl {
	
	public MetadataCleaner(XText text) {
		super(text);
	}

	@Override
	public void portionProperties(XPropertySet portionPoperties, XTextContent textContent) {
		String portionType = null;
		try {
			portionType = (String) portionPoperties.getPropertyValue("TextPortionType");
			if (portionType != null && portionType.equals("Annotation")) {
				Object annotation = portionPoperties.getPropertyValue("TextField");
	      XPropertySet annotationProperties = UnoRuntime.queryInterface(XPropertySet.class, annotation);
	    	String author = (String) annotationProperties.getPropertyValue("Author");
	      if (author != null && author.equals(METADATA_EXTENSION)) {
	      	XTextRange anchor = textContent.getAnchor();
	      	XText curText = anchor.getText();
	      	XTextField textField = UnoRuntime.queryInterface(XTextField.class, annotation);
	      	try {
						curText.removeTextContent( textField );
					} catch (NoSuchElementException e) {
						e.printStackTrace();
					}
	      }
			}
		} catch (UnknownPropertyException e) {
			e.printStackTrace();
		} catch (WrappedTargetException e) {
			e.printStackTrace();
		}
	}
}
